Skip to main content
Version: 5.35.0

Instance

Overview​

In object-oriented programming (OOP), an instance is a specific realization of a class. Similarly, in the scope of the Mobiscroll library, a component instance is a realization of the component class.

The instantiation (the creation of objects from a class) in case of the Mobiscroll components is done when the intialization function is called.

Getting the instance​

Inside events​

A reference to the component instance is available in every Mobiscroll event as the second argument of the event handler.

$('#my-div').mobiscroll().eventcalendar({
onEventCreate: (args, inst) => {
console.log('The Eventcalendar instance:', inst);
},
});

The getInst method​

A reference to the component instance is returned by the getInst function:

$('#my-div').mobiscroll().eventcalendar({ theme: 'ios' });

const inst = $('#my-div').mobiscroll('getInst');

console.log('The Eventcalendar instance:', inst);

The getInst function also receives a parameter. When true is passed to the parameter the form control instance will be returned. This is usefull when two components are initialized on the same element, for example: a mobiscroll input and a datepicker.

$('#my-inp').mobiscroll().input();
$('#my-inp').mobiscroll().datepicker();

const instDatepicker = $('#my-inp').mobiscroll('getInst'); // the main component instance
const instInput = $('#my-inp').mobiscroll('getInst', true); // the form component instance

Calling methods​

All the component methods are documented on each components API section. The methods can be called on the component instances as described in the previous section.

Example: Getting invalid dates for a date range​

One such a case when you might need to call an instance method would be to get the invalid data for a time period from the eventcalendar. Since the invalid data you pass to the Eventcalendar can contain recurring rules, you need a way to calculate the actual occurences. Luckily the Eventcalendar has a method that will return the actual occurences for a time period.

Invalid rule that repeats on specific days
const invalidsArray = [
{
start: '2023-10-18',
allDay: true,
recurring: {
repeat: 'weekly',
weekDays: 'MO,FR,SA',
interval: 1
}
}
];

To get the actual invalid days for the month of November, you can call the getInvalids method of the Eventcalendar instance.

// initialize the eventcalendar with the invalid rule
$('#my-div').mobiscroll().eventcalendar({
invalid: invalidsArray
});

// get the instance
const inst = $('#my-div').mobiscroll('getInst');
// query the invalid occurences
const occurences = inst.getInvalids('2023-11-01', '2023-12-01');

The result in this case will be an array of objects, each of them being an occurence of an invalid day in November.

Skip to main content
Version: 5.35.0

Instance

Overview​

In object-oriented programming (OOP), an instance is a specific realization of a class. Similarly, in the scope of the Mobiscroll library, a component instance is a realization of the component class.

The instantiation (the creation of objects from a class) in case of the Mobiscroll components is done by the Angular framework, and accessing the component instances are only needed in a few specific cases.

Getting the instance​

Inside events​

A reference to the component instance is available in every Mobiscroll event through the inst property of the first argument.

<mbsc-eventcalendar (onEventCreate)="myHandler($event)"></mbsc-eventcalendar>

Template references​

The mobiscroll directives and components are exported as 'mobiscroll' for template variables.

<mbsc-datepicker #myRef></mbsc-datepicker>
<input mbsc-datepicker #myRef="mobiscroll" />

Calling methods​

caution

Calling the instance methods should be necessary only in a few selected cases. Almost every case can be solved with passing props to the component and using it's events rather than calling instance methods. Before implementing a solution, please take into consideration using props and events first.

All the component methods are documented on each components API section. The methods can be called on the component instances directly in the templates or inside component classes using @ViewChild decorators.

Inside templates​

Calling methods in the template
<mbsc-popup #myPopup>
<p>Popup content</p>
</mbsc-popup>

<mbsc-button (click)="myPopup.open()">Open</mbsc-button

Inside classes​

import { CommonModule } from '@angular/common';
import { Component, ViewChild } from '@angular/core';
import { MbscModule, MbscPopup } from '@mobiscroll/angular';

@Component({
selector: 'component',
templateUrl: './component.html',
standalone: true,
imports: [CommonModule, MbscModule]
})
export class AppComponent {
@ViewChild('myPopup')
popupInst: MbscPopup | null = null;

openPopup() {
if (this.popupInst) {
this.popupInst.open();
}
}
}

Example: Getting invalid dates for a date range​

One such a case when you might need to call an instance method would be to get the invalid data for a time period from the eventcalendar. Since the invalid data you pass to the Eventcalendar can contain recurring rules, you need a way to calculate the actual occurences. Luckily the Eventcalendar has a method that will return the actual occurences for a time period.

Invalid rule that repeats on specific days
import { CommonModule } from '@angular/common';
import { Component } from '@angular/core';
import { MbscDateType, MbscModule } from '@mobiscroll/angular';

@Component({
selector: 'component',
templateUrl: './component.html',
standalone: true,
imports: [CommonModule, MbscModule]
})
export class AppComponent {
invalidsArray: MbscDateType[] = [{
start: '2023-10-18',
allDay: true,
recurring: {
repeat: 'weekly',
weekDays: 'MO,FR,SA',
interval: 1
}
}];
}

To get the actual invalid days for the month of November, you can call the getInvalids method of the Eventcalendar instance.

The invalids array needs to be passed to the eventcalendar
<mbsc-eventcalendar [invalid]="invalidsArray" #myCalendar />

Then you can query the invalid days through the instance:

import { CommonModule } from '@angular/common';
import { AfterViewInit, Component, ViewChild } from '@angular/core';
import { Eventcalendar, MbscDateType, MbscModule } from '@mobiscroll/angular';

@Component({
selector: 'component',
templateUrl: './component.html',
standalone: true,
imports: [CommonModule, MbscModule]
})
export class AppComponent implements AfterViewInit {
@ViewChild('myCalendar')
inst: Eventcalendar | null = null;

invalidsArray: MbscDateType[] = [{
start: '2023-10-18',
allDay: true,
recurring: {
repeat: 'weekly',
weekDays: 'MO,FR,SA',
interval: 1
}
}];

ngAfterViewInit(): void {
const occurences = this.inst!.getInvalids('2023-11-01', '2023-12-01');
}
}

The result in this case will be an array of objects, each of them being an occurence of an invalid day in November. The AfterViewInit interface is required, because the ViewChild references will only get a value after the view was initialized.

Skip to main content
Version: 5.35.0

Instance

Overview​

In object-oriented programming (OOP), an instance is a specific realization of a class. Similarly, in the scope of the Mobiscroll library, a component instance is a realization of the component class.

The instantiation (the creation of objects from a class) in case of the Mobiscroll components is done by the React framework, and accessing the component instances are only needed in a few specific cases.

Getting the instance​

Inside events​

A reference to the component instance is available in every Mobiscroll event as the second argument of the event handler.

function App() {
const myHandler = (args, inst) => {
console.log('The Eventcalendar instance:', inst);
}
return <Eventcalendar onEventCreate={myHandler} />
}

Using refs​

To get the instance of a component there is a special prop called ref and a hook useRef. These two are usually used toghether to obtain a reference to a DOM element, but it can also be used to obtain a reference to the Mobiscroll component instances.

Getting the instance of a Mobiscroll Eventcalendar
import { useRef } from "react";
import { Eventcalendar } from "@mobiscroll/react";

function App() {
const myRef = useRef(null);
return <Eventcalendar ref={myRef} />
}

The useRef hook returns an object with a "current" property that holds the actual value of the ref after it is available.

Calling methods​

caution

Calling the instance methods should be necessary only in a few selected cases. Almost every case can be solved with passing props to the component and using it's events rather than calling instance methods. Before implementing a solution, please take into consideration using props and events first.

All the component methods are documented on each components API section. The methods can be called on the component instances as described in the previous section.

Example: Getting invalid dates for a date range​

One such a case when you might need to call an instance method would be to get the invalid data for a time period from the eventcalendar. Since the invalid data you pass to the Eventcalendar can contain recurring rules, you need a way to calculate the actual occurences. Luckily the Eventcalendar has a method that will return the actual occurences for a time period.

Invalid rule that repeats on specific days
const invalidsArray = [
{
start: '2023-10-18',
allDay: true,
recurring: {
repeat: 'weekly',
weekDays: 'MO,FR,SA',
interval: 1
}
}
]

To get the actual invalid days for the month of November, you can call the getInvalids method of the Eventcalendar instance.

The invalids array needs to be passed to the eventcalendar
<Eventcalendar ref={myCalRef} invalid={invalidsArray} />
const getOccurences = () => {
const occurences = myCalRef.current.getInvalids('2023-11-01', '2023-12-01');
return occurences;
}

The result in this case will be an array of objects, each of them being an occurence of an invalid day in November.

Here's the example as a whole:

import { useRef, useState } from 'react';
import { Button, Eventcalendar } from '@mobiscroll/react';

function App() {
const myCalRef = useRef(null);
const [invalidsArray] = useState([{
start: '2023-10-18',
allDay: true,
recurring: {
repeat: 'weekly',
weekDays: 'MO,FR,SA',
interval: 1
}
}]);

const getOccurences = () => {
const occurences = myCalRef.current.getInvalids('2023-11-01', '2023-12-01');
return occurences;
}

const logOccurences = () => {
console.log(getOccurences());
}

return <>
<Button onClick={logOccurences}>Log</Button>
<Eventcalendar ref={myCalRef} invalid={invalidsArray} />
</>
}

Skip to main content
Version: 5.35.0

Instance

Overview​

In object-oriented programming (OOP), an instance is a specific realization of a class. Similarly, in the scope of the Mobiscroll library, a component instance is a realization of the component class.

The instantiation (the creation of objects from a class) in case of the Mobiscroll components is done by the Vue framework, and accessing the component instances are only needed in a few specific cases.

Getting the instance​

Inside events​

A reference to the component instance is available in every Mobiscroll event as the second argument of the event handler.

<script setup>
import { MbscEventcalendar } from "@mobiscroll/vue";

function myHandler(args, inst) {
console.log('The Eventcalendar instance:', inst);
}
</script>

<template>
<MbscEventcalendar @event-create="myHandler" />
</template>

Using refs​

To get the instance of a component there is a special attribute called ref. The ref attribute is used to obtain a direct reference to the DOM element it is placed on. In the case of components, the ref attribute will return the Vue component.

info

Usually for Vue components the public methods and properties are on the Vue component itself, returned by the ref attribute. In the case of the Mobiscroll Vue components, this is different. The instance property is the only accessible property and all the methods must be accessed through it.

Getting the instance of a Mobiscroll Eventcalendar
<script setup>
import { ref } from "vue";
import { MbscEventcalendar } from "@mobiscroll/vue";

const instRef = ref(null);

function log() {
const inst = instRef.value.instance;
console.log('The Eventcalendar instance:', inst);
}
</script>

<template>
<button @click="log">Log the instance</button>
<MbscEventcalendar ref="instRef" />
</template>

Calling methods​

caution

Calling the instance methods should be necessary only in a few selected cases. Almost every case can be solved with passing props to the component and using it's events rather than calling instance methods. Before implementing a solution, please take into consideration using props and events first.

All the component methods are documented on each components API section. The methods can be called on the component instances through the instance property as described in the previous section.

Example: Getting invalid dates for a date range​

One such a case when you might need to call an instance method would be to get the invalid data for a time period from the eventcalendar. Since the invalid data you pass to the Eventcalendar can contain recurring rules, you need a way to calculate the actual occurences. Luckily the Eventcalendar has a method that will return the actual occurences for a time period.

Invalid rule that repeats on specific days
const invalidsArray = [
{
start: '2023-10-18',
allDay: true,
recurring: {
repeat: 'weekly',
weekDays: 'MO,FR,SA',
interval: 1
}
}
]

To get the actual invalid days for the month of November, you can call the getInvalids method of the Eventcalendar instance.

The invalids array needs to be passed to the eventcalendar
<MbscEventcalendar ref="instRef" :invalid="invalidsArray" />
function getOccurences() {
const occurences = instRef.value.instance.getInvalids('2023-11-01', '2023-12-01');
}

The result in this case will be an array of objects, each of them being an occurence of an invalid day in November.